Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo.nml
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo.nml	(revision 4229)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo.nml	(revision 4229)
@@ -0,0 +1,44 @@
+
+!----------------------------------------------------------------------
+!       namooo Offline obs_oper namelist
+!----------------------------------------------------------------------
+!   ooo_files     specifies the files containing the model counterpart
+!   nn_ooo_idx    specifies the index within the model file
+!   nn_ooo_freq   specifies the number of timesteps between file reads
+&namooo
+   ooo_files = 'fcst.0.nc'
+   nn_ooo_idx = 1
+/
+!----------------------------------------------------------------------
+!       namcl4 Class 4 obs_oper namelist
+!----------------------------------------------------------------------
+!   cl4_date      the verfication date of the class 4 file
+!   cl4_vars      the name of the variable in the class 4 file
+!   cl4_sys       the forecast system being used e.g. FOAM
+!   cl4_cfg       the model configuration being used e.g. amm7
+!   cl4_vn        the version number e.g. 12.0
+!   cl4_prefix    prefix which denotes the output file
+!   cl4_contact   email address of file creator
+!   cl4_inst      institution related to the data within the file
+!   cl4_leadtime  lead time axis of class 4 file
+!   cl4_fcst_idx  output file forecast index
+!   cl4_fcst_len  output file forecast dimension length
+!   cl4_match_len number of match types
+!
+&namcl4
+   cl4_leadtime = 12
+   cl4_fcst_idx = 1
+   cl4_fcst_len = 1
+   cl4_match_len = 1
+   cl4_date = '20130101'
+   cl4_vars = 'forecast'
+   cl4_sys = 'FOAM'
+   cl4_cfg = 'amm7'
+   cl4_vn = '12.0'
+   cl4_prefix = 'class4'
+   cl4_contact = ''
+   cl4_inst = 'UK Met Office'
+/
+
+
+
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90	(revision 4229)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90	(revision 4229)
@@ -0,0 +1,142 @@
+MODULE ooo_data
+   !! =================================================================
+   !!                    *** MODULE ooo_data ***
+   !! =================================================================
+   USE par_kind, ONLY: lc
+
+   IMPLICIT NONE
+
+   !! Public data
+
+   INTEGER, PARAMETER :: MaxNumFiles = 1000
+
+   !! Class 4 file settings
+   INTEGER :: &
+           & cl4_fcst_idx(MaxNumFiles), & !: forecast indices
+           & cl4_match_len, &             !: number of match types
+           & cl4_fcst_len                 !: number of forecast days
+   CHARACTER(len=lc) :: &
+           & cl4_vars(MaxNumFiles), &  !: class 4 variables
+           & cl4_sys, &                !: class 4 system
+           & cl4_cfg, &                !: class 4 configuration
+           & cl4_date, &               !: class 4 date
+           & cl4_vn,  &                !: class 4 version
+           & cl4_prefix, &             !: class 4 prefix
+           & cl4_contact, &            !: class 4 contact
+           & cl4_inst                  !: class 4 institute
+   REAL ::   cl4_modjuld               !: model Julian day
+   REAL :: &
+      & cl4_leadtime(MaxNumFiles)      !: Lead time data
+
+   !! Offline obs_oper settings
+   CHARACTER(len=lc) :: &
+      & ooo_files(MaxNumFiles)         !: model files
+   INTEGER            :: &
+      & jifile, &                      !: current file list index
+      & n_files, &                     !: number of files
+      & jimatch, &                     !: current match
+      & nn_ooo_idx(MaxNumFiles), &     !: time_counter indices
+      & nn_ooo_freq                    !: read frequency in time steps
+   CHARACTER(len=128) :: &
+      & alt_file                       !: altimeter file
+CONTAINS
+   SUBROUTINE ooo_data_init( ld_cl4 )
+      !!----------------------------------------------------------------------
+      !!                    ***  SUBROUTINE ooo_data_init ***
+      !!
+      !! ** Purpose : To read namelists and initialise offline_oper run.
+      !!
+      !!----------------------------------------------------------------------
+      USE in_out_manager
+      INTEGER            :: &
+         & jf                           !: file dummy loop index
+      LOGICAL :: lmask(MaxNumFiles)     !: Logical mask used for counting
+      LOGICAL, INTENT(IN) :: ld_cl4     !: Logical class 4 on/off
+
+      ! Standard offline obs_oper information
+      NAMELIST/namooo/ooo_files, nn_ooo_idx, nn_ooo_freq
+
+      ! Class 4 file specifiers
+      NAMELIST/namcl4/cl4_vars, cl4_sys, cl4_cfg, cl4_date, cl4_vn, &
+         &            cl4_prefix, cl4_contact, cl4_inst, cl4_leadtime, &
+         &            cl4_fcst_idx, cl4_fcst_len, cl4_match_len
+
+      ! Standard offline obs_oper initialisation
+      jimatch = 0                   !: match-up iteration variable 
+      jifile = 1                    !: input file iteration variable 
+      n_files = 0                   !: number of files to cycle through
+      ooo_files(:) = ''             !: list of files to read in
+      nn_ooo_idx(:) = 0             !: list of indices inside each file
+      nn_ooo_freq = -1              !: input frequency in time steps
+
+      ! Class 4 initialisation
+      cl4_leadtime(:) = 0           !: Lead time axis value for each file
+      cl4_fcst_len = 0              !: Length of the forecast dimension
+      cl4_match_len = 1             !: Number of match types
+      cl4_fcst_idx(:) = 0           !: output file forecast index
+      cl4_vars(:) = ''              !: output file variable names
+      cl4_sys = ''                  !: output file system
+      cl4_cfg = ''                  !: output file configuration
+      cl4_date = ''                 !: output file date string
+      cl4_vn = ''                   !: output file version
+      cl4_prefix = 'class4'         !: output file prefix
+      cl4_contact = ''              !: output file contact details
+      cl4_inst = ''                 !: output file institution
+
+      ! Standard offline obs_oper settings
+      READ(numnam, namooo)
+
+      ! Read class 4 output settings
+      IF (ld_cl4) THEN
+         READ(numnam, namcl4)
+      ENDIF
+
+      ! count input files
+      lmask(:) = .FALSE.
+      WHERE (ooo_files(:) /= '') lmask(:) = .TRUE.
+      n_files = COUNT(lmask)
+
+      !! Initialise sub obs window frequency
+      IF (nn_ooo_freq == -1) THEN
+         !! Run length
+         nn_ooo_freq = nitend - nit000 + 1
+      ENDIF
+
+      !! Print summary of settings
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'offline obs_oper : Initialization'
+         WRITE(numout,*) '~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '   Namelist namooo : set offline obs_oper parameters' 
+         DO jf = 1, n_files
+            WRITE(numout,'(1X,2A)') '   Input forecast file name          forecastfile = ', &
+               TRIM(ooo_files(jf))
+            WRITE(numout,*) '   Input forecast file index        forecastindex = ', &
+               nn_ooo_idx(jf)
+            WRITE(numout,*) '   Output forecast leadtime index   leadtimeindex = ', &
+               cl4_fcst_idx(jf)
+            WRITE(numout,*) '   Output forecast leadtime value   leadtimevalue = ', &
+               cl4_leadtime(jf)
+            WRITE(numout,'(1X,2A)') '   Input class 4 variable       class 4 parameter = ', &
+               TRIM(cl4_vars(jf))
+         END DO
+         WRITE(numout, '(1X,2A)') '   Input class 4 system            class 4 system = ', &
+            TRIM(cl4_sys)
+         WRITE(numout, '(1X,2A)') '   Input class 4 config            class 4 config = ', &
+            TRIM(cl4_cfg)
+         WRITE(numout, '(1X,2A)') '   Input class 4 date                class 4 date = ', &
+            TRIM(cl4_date)
+         WRITE(numout, '(1X,2A)') '   Input class 4 version          class 4 version = ', &
+            TRIM(cl4_vn)
+         WRITE(numout, '(1X,2A)') '   Input class 4 prefix            class 4 prefix = ', &
+            TRIM(cl4_prefix)
+         WRITE(numout, '(1X,2A)') '   Input class 4 contact          class 4 contact = ', &
+            TRIM(cl4_contact)
+         WRITE(numout, '(1X,2A)') '   Input class 4 institute      class 4 institute = ', &
+            TRIM(cl4_inst)
+      END IF
+
+   END SUBROUTINE ooo_data_init
+
+END MODULE ooo_data
+
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90	(revision 4229)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90	(revision 4229)
@@ -0,0 +1,48 @@
+MODULE ooo_intp
+   !!======================================================================
+   !!                    ***  MODULE ooo_intp ***
+   !! ** Purpose : Run NEMO observation operator in offline mode
+   !!======================================================================
+   !! NEMO modules
+   USE in_out_manager
+   USE diaobs
+   !! Offline obs_oper modules
+   USE ooo_read
+   USE ooo_data
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC ooo_interp
+
+   CONTAINS
+
+      SUBROUTINE ooo_interp
+         !!----------------------------------------------------------------------
+         !!                    ***  SUBROUTINE ooo_interp ***
+         !!
+         !! ** Purpose : To interpolate the model as if it were running online.
+         !!
+         !! ** Method : 1. Populate model counterparts
+         !!             2. Call dia_obs at appropriate time steps
+         !!----------------------------------------------------------------------
+         INTEGER :: istp ! time step index
+         !! Loop over entire run
+         istp = nit000
+         nstop = 0
+         DO WHILE ( istp <= nitend .AND. nstop == 0 )
+            IF (jifile <= n_files + 1) THEN
+               IF ( MOD(istp, nn_ooo_freq) == nit000 ) THEN
+                  !! Read next model counterpart
+                  CALL ooo_rea_dri(jifile)
+                  jifile = jifile + 1
+               ENDIF
+               !! Interpolate single time step
+               CALL dia_obs(istp)
+            ENDIF
+            !! Increment model step
+            istp = istp + 1
+         END DO
+      END SUBROUTINE ooo_interp
+
+END MODULE ooo_intp
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90	(revision 4229)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90	(revision 4229)
@@ -0,0 +1,347 @@
+
+MODULE ooo_read
+   !!==================================================================
+   !!                    *** MODULE ooo_read ***
+   !! Read routines : I/O for offline obs_oper
+   !!==================================================================
+
+   USE mppini
+   USE lib_mpp
+   USE in_out_manager
+   USE par_kind, ONLY: lc
+   USE netcdf
+   USE oce,     ONLY: tsn, sshn
+   USE dom_oce, ONLY: nlci, nlcj, nimpp, njmpp, tmask
+   USE par_oce, ONLY: jpi, jpj, jpk
+   USE obs_fbm, ONLY: fbimdi, fbrmdi, fbsp, fbdp
+   USE ooo_data
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC ooo_rea_dri
+
+CONTAINS
+   SUBROUTINE ooo_rea_dri(kfile)
+      !!------------------------------------------------------------------------
+      !!             *** ooo_rea_dri ***
+      !!
+      !! Purpose : To choose appropriate read method
+      !! Method  : 
+      !!
+      !! Author  : A. Ryan Oct 2013
+      !!
+      !!------------------------------------------------------------------------
+      INTEGER, INTENT(IN) :: &
+              & kfile         !: File number
+      CHARACTER(len=lc) :: &
+              & cdfilename, & !: File name
+              & cmatchname    !: Match name
+      INTEGER :: &
+              & kindex       !: File index to read
+ 
+      !! Filename, index and match-up kind
+      cdfilename = TRIM(ooo_files(kfile))
+      cmatchname = TRIM(cl4_vars(kfile))
+      kindex = nn_ooo_idx(kfile)
+
+      !! Update model fields
+      !! Class 4 variables: forecast, persistence,
+      !!                    nrt_analysis, best_estimate
+      !! Feedback variables: empty string
+      IF ( (TRIM(cmatchname) == 'forecast') .OR. &
+         & (TRIM(cmatchname) == 'persistence') .OR. &
+         & (TRIM(cmatchname) == 'nrt_analysis') .OR. &
+         & (TRIM(cmatchname) == 'best_estimate').OR. &
+         & (TRIM(cmatchname) == '') ) THEN
+         CALL ooo_read_file(TRIM(cdfilename), kindex)
+         CALL ooo_read_juld(TRIM(cdfilename), kindex, cl4_modjuld)
+      ELSE IF (TRIM(cmatchname) == 'climatology') THEN
+         WRITE(numout,*) 'Interpolating climatologies'
+      ELSE IF (TRIM(cmatchname) == 'altimeter') THEN
+         CALL ooo_read_altbias(TRIM(cdfilename))
+         CALL ooo_read_juld(TRIM(cdfilename), kindex, cl4_modjuld)
+      END IF
+
+   END SUBROUTINE ooo_rea_dri
+
+   SUBROUTINE ooo_read_altbias(filename)
+      !!------------------------------------------------------------------------
+      !!                      *** ooo_read_altbias ***
+      !!
+      !! Purpose : To read altimeter bias and set tn,sn to missing values
+      !! Method  : Use subdomain indices to create start and count matrices
+      !!           for netcdf read.
+      !!
+      !! Author  : A. Ryan Sept 2012
+      !!------------------------------------------------------------------------
+      CHARACTER(len=*), INTENT(IN) :: filename
+      INTEGER                      :: ncid, &
+                                    & varid,&
+                                    & istat,&
+                                    & ntimes,&
+                                    & tdim, &
+                                    & xdim, &
+                                    & ydim, &
+                                    & zdim
+      INTEGER                      :: ii, ij, ik
+      INTEGER, DIMENSION(3)        :: start_s, &
+                                    & count_s
+      REAL(fbdp), DIMENSION(:,:),  ALLOCATABLE :: temp_sshn
+      REAL(fbdp)                     :: fill_val
+
+      IF (TRIM(filename) == 'nofile') THEN
+         tsn(:,:,:,:) = fbrmdi
+         sshn(:,:) = fbrmdi 
+      ELSE
+         ! Open Netcdf file to find dimension id
+         istat = nf90_open(trim(filename),nf90_nowrite,ncid)
+         istat = nf90_inq_dimid(ncid,'x',xdim)
+         istat = nf90_inq_dimid(ncid,'y',ydim)
+         istat = nf90_inq_dimid(ncid,'deptht',zdim)
+         istat = nf90_inq_dimid(ncid,'time',tdim)
+         istat = nf90_inquire_dimension(ncid, tdim, len=ntimes)
+         ! Allocate temporary temperature array
+         ALLOCATE(temp_sshn(nlci,nlcj))
+         ! Create start and count arrays
+         start_s = (/ nimpp, njmpp, 1 /)
+         count_s = (/ nlci,  nlcj,  1 /)
+          
+         ! Altimeter bias
+         istat = nf90_inq_varid(ncid,'altbias',varid)
+         istat = nf90_get_att(ncid, varid, '_FillValue', fill_val)
+         istat = nf90_get_var(ncid, varid, temp_sshn, start_s, count_s)
+         WHERE(temp_sshn(:,:) == fill_val) temp_sshn(:,:) = fbrmdi
+   
+         ! Initialise tsn, sshn to fbrmdi
+         tsn(:,:,:,:) = fbrmdi
+         sshn(:,:) = fbrmdi 
+
+         ! Fill sshn with altimeter bias 
+         sshn(1:nlci,1:nlcj) = temp_sshn(:,:) * tmask(1:nlci,1:nlcj,1)
+
+         ! Remove halo from tmask, sshn to prevent double obs counting
+         IF (jpi > nlci) THEN
+             tmask(nlci+1:,:,:) = 0
+             sshn(nlci+1:,:) = 0
+         END IF
+         IF (jpj > nlcj) THEN
+             tmask(:,nlcj+1:,:) = 0
+             sshn(:,nlcj+1:) = 0
+         END IF
+
+         ! Deallocate arrays
+         DEALLOCATE(temp_sshn)
+
+         ! Close netcdf file
+         istat = nf90_close(ncid)
+      END IF
+   
+   END SUBROUTINE ooo_read_altbias
+
+   SUBROUTINE ooo_read_file(filename, ifcst)
+      !!------------------------------------------------------------------------
+      !!             *** ooo_read_file ***
+      !!
+      !! Purpose : To fill tn and sn with dailymean field from netcdf files
+      !! Method  : Use subdomain indices to create start and count matrices
+      !!           for netcdf read.
+      !!
+      !! Author  : A. Ryan Oct 2010
+      !!------------------------------------------------------------------------
+
+      INTEGER,          INTENT(IN) :: ifcst
+      CHARACTER(len=*), INTENT(IN) :: filename
+      INTEGER                      :: ncid, &
+                                    & varid,&
+                                    & istat,&
+                                    & ntimes,&
+                                    & tdim, &
+                                    & xdim, &
+                                    & ydim, &
+                                    & zdim
+      INTEGER                      :: ii, ij, ik
+      INTEGER, DIMENSION(4)        :: start_n, &
+                                    & count_n
+      INTEGER, DIMENSION(3)        :: start_s, &
+                                    & count_s
+      REAL(fbdp), DIMENSION(:,:,:),ALLOCATABLE :: temp_tn, &
+                                              & temp_sn
+      REAL(fbdp), DIMENSION(:,:),  ALLOCATABLE :: temp_sshn
+      REAL(fbdp)                     :: fill_val
+
+      ! DEBUG
+      INTEGER :: istage
+
+      IF (TRIM(filename) == 'nofile') THEN
+         tsn(:,:,:,:) = fbrmdi
+         sshn(:,:) = fbrmdi 
+      ELSE
+         WRITE(numout,*) "Opening :", TRIM(filename)
+         ! Open Netcdf file to find dimension id
+         istat = nf90_open(path=TRIM(filename), mode=nf90_nowrite, ncid=ncid)
+         IF ( istat /= nf90_noerr ) THEN
+             WRITE(numout,*) "WARNING: Could not open ", trim(filename)
+             WRITE(numout,*) "ERROR: ", nf90_strerror(istat)
+         ENDIF
+         istat = nf90_inq_dimid(ncid,'x',xdim)
+         istat = nf90_inq_dimid(ncid,'y',ydim)
+         istat = nf90_inq_dimid(ncid,'deptht',zdim)
+         istat = nf90_inq_dimid(ncid,'time_counter',tdim)
+         istat = nf90_inquire_dimension(ncid, tdim, len=ntimes)
+         IF (ifcst .LE. ntimes) THEN   
+            ! Allocate temporary temperature array
+            ALLOCATE(temp_tn(nlci,nlcj,jpk))
+            ALLOCATE(temp_sn(nlci,nlcj,jpk))
+            ALLOCATE(temp_sshn(nlci,nlcj))
+      
+            ! Set temp_tn, temp_sn to 0.
+            temp_tn(:,:,:) = fbrmdi
+            temp_sn(:,:,:) = fbrmdi
+            temp_sshn(:,:) = fbrmdi
+      
+            ! Create start and count arrays
+            start_n = (/ nimpp, njmpp, 1,   ifcst /)
+            count_n = (/ nlci,  nlcj,  jpk, 1     /)
+            start_s = (/ nimpp, njmpp, ifcst /)
+            count_s = (/ nlci,  nlcj,  1     /)
+             
+            ! Read information into temporary arrays
+            ! retrieve varid and read in temperature
+            istat = nf90_inq_varid(ncid,'votemper',varid)
+            istat = nf90_get_att(ncid, varid, '_FillValue', fill_val)
+            istat = nf90_get_var(ncid, varid, temp_tn, start_n, count_n)
+            WHERE(temp_tn(:,:,:) == fill_val) temp_tn(:,:,:) = fbrmdi
+      
+            ! retrieve varid and read in salinity
+            istat = nf90_inq_varid(ncid,'vosaline',varid)
+            istat = nf90_get_att(ncid, varid, '_FillValue', fill_val)
+            istat = nf90_get_var(ncid, varid, temp_sn, start_n, count_n)
+            WHERE(temp_sn(:,:,:) == fill_val) temp_sn(:,:,:) = fbrmdi
+      
+            ! retrieve varid and read in SSH
+            istat = nf90_inq_varid(ncid,'sossheig',varid)
+            IF (istat /= nf90_noerr) THEN
+               ! Altimeter bias
+               istat = nf90_inq_varid(ncid,'altbias',varid)
+            END IF
+      
+            istat = nf90_get_att(ncid, varid, '_FillValue', fill_val)
+            istat = nf90_get_var(ncid, varid, temp_sshn, start_s, count_s)
+            WHERE(temp_sshn(:,:) == fill_val) temp_sshn(:,:) = fbrmdi
+   
+            ! Initialise tsn, sshn to fbrmdi
+            tsn(:,:,:,:) = fbrmdi
+            sshn(:,:) = fbrmdi 
+
+            ! Mask out missing data index
+            tsn(1:nlci,1:nlcj,1:jpk,1) = temp_tn(:,:,:) * tmask(1:nlci,1:nlcj,1:jpk)
+            tsn(1:nlci,1:nlcj,1:jpk,2) = temp_sn(:,:,:) * tmask(1:nlci,1:nlcj,1:jpk)
+            sshn(1:nlci,1:nlcj)        = temp_sshn(:,:) * tmask(1:nlci,1:nlcj,1)
+
+            ! Remove halo from tmask, tsn, sshn to prevent double obs counting
+            IF (jpi > nlci) THEN
+                tmask(nlci+1:,:,:) = 0
+                tsn(nlci+1:,:,:,1) = 0
+                tsn(nlci+1:,:,:,2) = 0
+                sshn(nlci+1:,:) = 0
+            END IF
+            IF (jpj > nlcj) THEN
+                tmask(:,nlcj+1:,:) = 0
+                tsn(:,nlcj+1:,:,1) = 0
+                tsn(:,nlcj+1:,:,2) = 0
+                sshn(:,nlcj+1:) = 0
+            END IF
+
+            ! Deallocate arrays
+            DEALLOCATE(temp_tn, temp_sn, temp_sshn)
+         ELSE   
+            ! Mark all as missing data
+            tsn(:,:,:,:) = fbrmdi
+            sshn(:,:) = fbrmdi 
+         ENDIF
+         ! Close netcdf file
+         WRITE(numout,*) "Closing :", TRIM(filename)
+         istat = nf90_close(ncid)
+      END IF
+   END SUBROUTINE ooo_read_file
+
+   SUBROUTINE ooo_read_juld(filename, ifcst, julian)
+      USE calendar
+      !!--------------------------------------------------------------------
+      !!                 *** ooo_read_juld ***
+      !!
+      !!   Purpose : To read model julian day information from file
+      !!   Author  : A. Ryan Nov 2010
+      !!--------------------------------------------------------------------
+
+      !! Routine arguments
+      CHARACTER(len=*), INTENT(IN)  :: filename
+      INTEGER,          INTENT(IN)  :: ifcst
+      REAL,             INTENT(OUT) :: julian    !: Julian day
+
+      !! Local variables
+      INTEGER :: year,  &   !: Date information
+               & month, &
+               & day,   &
+               & hour,  &
+               & minute,&
+               & second
+      INTEGER :: istat, &   !: Netcdf variables
+               & ncid,  &
+               & dimid, &
+               & varid, &
+               & ntime      
+      REAL,DIMENSION(:),ALLOCATABLE :: r_sec     !: Remainder seconds
+      CHARACTER(len=120) :: time_str  !: time string
+
+      time_str=''
+      !! Read in time_counter and remainder seconds
+      istat = nf90_open(trim(filename),nf90_nowrite,ncid)
+      istat = nf90_inq_dimid(ncid,'time_counter',dimid)
+      IF (istat /= nf90_noerr) THEN
+          istat = nf90_inq_dimid(ncid,'time',dimid)
+      ENDIF
+      istat = nf90_inquire_dimension(ncid,dimid,len=ntime)
+      istat = nf90_inq_varid(ncid,'time_counter',varid)
+      IF (istat /= nf90_noerr) THEN
+          istat = nf90_inq_dimid(ncid,'time',dimid)
+      ENDIF
+      istat = nf90_get_att(ncid,varid,'units',time_str)
+      ALLOCATE(r_sec(ntime))
+      istat = nf90_get_var(ncid,varid, r_sec)
+      istat = nf90_close(ncid)
+
+      !! Fill yyyy-mm-dd hh:mm:ss
+      !! format(('seconds since ', I4.4,'-',I2.2,'-',I2.2,' ',I2.2,':',I2.2,':',I2.2))
+      100 format((14x, I4.4,1x,I2.2,1x,I2.2,1x,I2.2,1x,I2.2,1x,I2.2))
+      READ( time_str, 100 ) year, month, day, hour, minute, second
+
+      CALL ymds2ju(year, month, day, r_sec(ifcst), julian)
+
+      !! To take a comment from the ymds2ju subroutine
+
+   !- In the case of the Gregorian calendar we have chosen to use
+   !- the Lilian day numbers. This is the day counter which starts
+   !- on the 15th October 1582.
+   !- This is the day at which Pope Gregory XIII introduced the
+   !- Gregorian calendar.
+   !- Compared to the true Julian calendar, which starts some
+   !- 7980 years ago, the Lilian days are smaler and are dealt with
+   !- easily on 32 bit machines. With the true Julian days you can only
+   !- the fraction of the day in the real part to a precision of
+   !- a 1/4 of a day with 32 bits.
+      
+      !! The obs operator routines prefer to calculate Julian days since 
+      !! 01/01/1950 00:00:00
+      !! In order to convert to the 1950 version we must adjust by the number
+      !! of days between 15th October 1582 and 1st Jan 1950
+
+      julian = julian - 134123.
+      
+      DEALLOCATE(r_sec)
+      
+   END SUBROUTINE ooo_read_juld
+
+END MODULE ooo_read 
+
Index: branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90
===================================================================
--- branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90	(revision 4229)
+++ branches/2013/dev_MERCATOR_UKMO_2013/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90	(revision 4229)
@@ -0,0 +1,102 @@
+MODULE ooo_utils
+   !! =================================================================
+   !!                    *** MODULE ooo_utils ***
+   !! =================================================================
+   USE par_oce
+
+   IMPLICIT NONE
+
+   ! Define double precision obfillflt
+   REAL(kind=dp), PARAMETER :: obfilldbl=99999.
+
+   CONTAINS
+
+   SUBROUTINE yyyymmdd_to_ref_date(indate, intime, outstring)
+      !----------------------------------------
+      ! Routine to create reference date string
+      !----------------------------------------
+      ! Routine arguments
+      CHARACTER(len=8),  INTENT(IN)  :: indate    ! yyyymmdd
+      CHARACTER(len=6),  INTENT(IN)  :: intime    ! hhmmss
+      CHARACTER(len=23), INTENT(OUT) :: outstring ! yyyy-mm-dd hh:mm:ss utc
+      ! Local variables
+      CHARACTER(len=4)  :: year      ! yyyy
+      CHARACTER(len=2)  :: month     ! mm
+      CHARACTER(len=2)  :: day       ! dd
+      CHARACTER(len=2)  :: hour      ! hh
+      CHARACTER(len=2)  :: minute    ! mm
+      CHARACTER(len=2)  :: second    ! ss
+
+      year   = indate(1:4)
+      month  = indate(5:6)
+      day    = indate(7:8)
+      hour   = intime(1:2)
+      minute = intime(3:4)
+      second = intime(5:6)
+
+      outstring = year//"-"//month//"-"//day//" "//hour//":"//minute//":"//second//" utc"
+      
+   END SUBROUTINE yyyymmdd_to_ref_date
+
+   SUBROUTINE date_format(date_str)
+      !---------------------------------------
+      ! Routine to create creation date string
+      !---------------------------------------
+
+      ! Routine arguments
+      CHARACTER(len=*), INTENT(OUT) :: date_str
+      ! Local variables
+      CHARACTER(8)  :: date
+      CHARACTER(10) :: time
+
+      CHARACTER(10)  :: date_part
+      CHARACTER(8)  :: time_part
+
+      CALL date_and_time(DATE=date)
+      CALL date_and_time(TIME=time)
+      date_part  = date(1:4)//'/'//date(5:6)//'/'//date(7:8)
+      time_part  = time(1:2)//':'//time(3:4)//':'//time(5:6)
+
+      date_str   = date_part//' '//time_part
+
+   END SUBROUTINE date_format
+
+   SUBROUTINE inst_converter(wmo_inst_list, nprofs, obs_names)
+      !---------------------------------------
+      ! Routine to convert WMO_INST_TYPE to
+      ! 'ARGO', 'TESAC', 'XBT', 'BUOYS'
+      !---------------------------------------
+
+      !! Routine arguments
+      INTEGER,                             INTENT(IN) :: nprofs
+      CHARACTER(len=*),DIMENSION(nprofs),  INTENT(IN) :: wmo_inst_list      
+      CHARACTER(len=128),DIMENSION(nprofs),INTENT(OUT):: obs_names
+
+      !! Local variables
+      INTEGER :: inam !: loop over name
+
+      !! Initialise obs_names
+      obs_names(:) = ''
+
+      !! Convert number to text
+      DO inam = 1,nprofs
+         IF (trim(adjustl(wmo_inst_list(inam))) .EQ. '820') THEN
+            obs_names(inam) = 'BUOYS'
+         ELSEIF (trim(adjustl(wmo_inst_list(inam))) .EQ. '401') THEN
+            obs_names(inam) = 'XBT'
+         ELSEIF (trim(adjustl(wmo_inst_list(inam))) .EQ. '741') THEN
+            obs_names(inam) = 'TESAC'
+         ELSEIF (trim(adjustl(wmo_inst_list(inam))) .EQ. '831') THEN
+            obs_names(inam) = 'ARGO'
+         ELSEIF (trim(adjustl(wmo_inst_list(inam))) .EQ. '22') THEN ! Special case for AATSR
+            obs_names(inam) = '22'
+         ELSEIF (trim(adjustl(wmo_inst_list(inam))) .EQ. '') THEN
+            obs_names(inam) = 'UNKNOWN'
+         ELSE 
+            obs_names(inam) = adjustl(wmo_inst_list(inam)) ! For all other cases
+         ENDIF
+      ENDDO
+
+   END SUBROUTINE inst_converter
+
+END MODULE ooo_utils
